Request

Response

    Bids
    GET

    bids/{bidId}/plugs

    Retrieves a list of all of the specified bid’s plugs. A plug is the adjusted value of a bid line item, created using the bid leveling form.

    Note that the plug is associated with a particular bid line item using the lineItemFingerprint object.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/construction/buildingconnected/v2/bids/{bidId}/plugs
    Authentication Context
    User context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    * Required

    Request

    URI Parameters

    bidId
    string
    The unique ID of the bid.

    Request

    Query String Parameters

    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    limit
    int
    The maximum number of records that the endpoint may return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last page of a set is returned.

    Default value: 100

    Response

    HTTP Status Code Summary

    200
    OK
    OK
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    Details of the plugs applied to the specified bid. A plug is an adjusted value of a bid line item, created using BuildingConnected bid leveling.
    id
    string
    The unique ID of the plug.

    Max length: 24

    quantity
    number
    The adjusted quantity of the associated line item.

    Note that this value is null under either of the following conditions:

    • The value of the line item’s type is neither ALTERNATE nor COST_BREAKDOWN.
    • The value of the line item’s unit is TOTAL_COST_ONLY or TEXT.
    unitCost
    number
    The adjusted cost per unit of the associated line item. This is not the total cost of the line item.

    Note that this value is null under either of the following conditions:

    • The value of the line item’s type is neither ALTERNATE nor COST_BREAKDOWN.
    • The value of the line item’s unit is TOTAL_COST_ONLY or TEXT.
    value
    one of
    The adjusted value of the line item. Note the following requirements:
    • If the line item’s unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT, this field is a string. Otherwise, it is a number.
    • If the line item’s type is SCOPE_CLARIFICATION or DISCLAIMER, this field is null.
    • If the line item’s type is ALTERNATE or COST_BREAKDOWN, this field contains the adjusted total cost. In that case:

      • If the adjusted value of quantity is null, value is the value that was entered directly.
      • If the adjusted value of quantity is not null, value is not relevant. The total value is calculated by multiplying quantity and unitCost.
    0
    string
    The adjusted value as a string. Applies when the line item’s unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT.

    Max length: 65536

    1
    number
    The adjusted value as a number. Applies for all other unit types.
    createdBy
    string
    User ID of the user who first created the plug.

    Max length: 24

    updatedBy
    string
    User ID of the user who most recently updated the plug.

    Max length: 24

    createdAt
    datetime: ISO 8601
    The date and time that the plug was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time that the plug was last updated, in ISO 8601 format.
    lineItemFingerprint
    object
    Details that identify a line item.
    type
    enum:string
    The line item’s type. Possible values: ADDENDUM, ALTERNATE, COST_BREAKDOWN, INCLUSION, ACKNOWLEDGMENT, BONDING, CERTIFICATION, MARKUP, LABOR_RATE
    description
    string
    The description of the line item. This string is all lowercase.

    Max length: 65536

    section
    string
    The bid section that the line item is under. This string is all lowercase.

    Note that this value is null if the item is not under a section.

    Max length: 65536

    unit
    enum:string
    The unit format of the line item. Possible values: ACRES, ADD_DEDUCT, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, PERCENTAGE, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS, YES_NO, YES_NO_WITH_ADJUSTMENT
    code
    string
    The code associated with the line item. This string is all lowercase.

    Note that this value is null if type is not COST_BREAKDOWN.

    Max length: 65536

    Example

    OK

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/bids/:bidId/plugs' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": 100,
        "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
        "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
      },
      "results": [
        {
          "id": "5f8104b87e392d56e1e4b4ad",
          "quantity": 20,
          "unitCost": 500,
          "value": 10000,
          "createdBy": "5f8104b87e392d56e1e4f7ad",
          "updatedBy": "5f8104b87e392d56e1e4f7ad",
          "createdAt": "2021-08-19T23:07:16.083Z",
          "updatedAt": "2021-08-20T23:07:16.083Z",
          "lineItemFingerprint": {
            "type": "COST_BREAKDOWN",
            "description": "duct insulation",
            "section": "furnish & install",
            "unit": "HOURS",
            "code": "d2"
          }
        }
      ]
    }
    
    Show More